var sqlite3 = require('sqlite3');
var open = require('sqlite').open;

function calculateWeight(node, allLinks) {
    let suma = 0;
    let links = allLinks.filter(e => e.parent_id==node).forEach(x => suma += calculateWeight(x.child_id,allLinks) + 1);
    return suma;
}


var repository = {
    create: async (entity) => {
         // Inserts entity in db table, id should be missing and autogenerated
         const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        let domain = await db.run('INSERT INTO domain (name, description) VALUES (@name, @description)',
            { '@name': entity.name, '@description': entity.description });

        await db.close();
        return { id: domain.lastID };
    },
    update: async (entity) => {
        // Updates entity of given id in db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        let domain = await db.run('UPDATE domain SET name = @name, description = @description WHERE id = @id',
            { '@name': entity.name, '@description': entity.description, '@id': entity.id });

        await db.close();
        return { id: domain.lastID };
    },
    delete: async (id) => {
        // Deletes entity of given id from db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        var stmt = await db.prepare('SELECT * FROM problem WHERE domain_id = @domain_id', { '@domain_id': id });
        let problems = await stmt.all();
        await stmt.finalize();

        for (let i = 0; i < problems.length; i++) {
            let problem = problems[i];

            stmt = await db.prepare('SELECT * FROM question WHERE problem_id = @id',
                { '@id': problem });

            let result = await stmt.all();
            await stmt.finalize();

            if (result.length > 0) {
                await db.close();
                throw new Error('At least one question is attached to some problem, so you can\'t delete it.');
            }
        }

        let result;
        for (let i = 0; i < problems.length; i++) {
            let problem = problems[i];

            result = await db.run('DELETE FROM problem_relation WHERE parent_id = @id OR child_id = @id',
                { '@id': problem.id });

            result = await db.run('DELETE FROM problem WHERE id = @id',
                { '@id': problem.id });
        }

        result = await db.run('DELETE FROM domain WHERE id = @id',
            { '@id': id });

        await db.close();
        return result;
    },
    exists: async (id) => {
        // Returns True if entity with given id exists in db table, false otherwise
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM domain WHERE id = @id',
            { '@id': id });

        let result = await stmt.get();
        await stmt.finalize();

        await db.close();
        return result != null;
    },
    count: async () => {
        // Returns total number of entities in db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM domain');

        let result = await stmt.all();
        await stmt.finalize();

        await db.close();
        return result.length;
    },
    findById: async (id) => {
        // Returns entity with given id from db table, null if not existent
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        var stmt = await db.prepare('SELECT * FROM domain WHERE id = @id', { '@id': id });
        let domain = await stmt.get();
        await stmt.finalize();

        stmt = await db.prepare('SELECT * FROM problem WHERE domain_id = @domain_id', { '@domain_id': domain.id });
        let problems = await stmt.all();
        await stmt.finalize();

        let relations = [];
        for (let i = 0; i < problems.length; i++) {
            let problem = problems[i];

            stmt = await db.prepare('SELECT * FROM problem_relation WHERE parent_id = @problem_id OR child_id = @problem_id', { '@problem_id': problem.id });
            let problem_relations = await stmt.all();
            await stmt.finalize();

            relations = relations.concat(problem_relations);
        }

        relations = relations.filter((rel1, index, self) =>
            index === self.findIndex((rel2) => (
                rel1.parent_id === rel2.parent_id && rel1.child_id === rel2.child_id
            ))
        );

        domain.problems = problems;
        domain.relations = relations;

        for (let i of domain.problems) {
            i.weight = calculateWeight(i.id, domain.relations)
        }

        await db.close()
        return domain;
    },
    getAll: async () => {
        // Returns all entities from db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        var stmt = await db.prepare('SELECT * FROM domain');
        let domains = await stmt.all();
        await stmt.finalize();

        for (let i = 0; i < domains.length; i++) {
            let domain = domains[i];

            stmt = await db.prepare('SELECT * FROM problem WHERE domain_id = @domain_id', { '@domain_id': domain.id });
            let problems = await stmt.all();
            await stmt.finalize();

            let relations = [];
            for (let j = 0; j < problems.length; j++) {
                let problem = problems[j];

                stmt = await db.prepare('SELECT * FROM problem_relation WHERE parent_id = @problem_id OR child_id = @problem_id', { '@problem_id': problem.id });
                let problem_relations = await stmt.all();
                await stmt.finalize();

                relations = relations.concat(problem_relations);
            }

            relations = relations.filter((rel1, index, self) =>
                index === self.findIndex((rel2) => (
                    rel1.parent_id === rel2.parent_id && rel1.child_id === rel2.child_id
                ))
            );

            domain.problems = problems;
            domain.relations = relations;
        }

        await db.close()
        return domains;
    },
    getDomainForTest: async (testid) => {
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        var stmt = await db.prepare('select * from domain where (select COUNT(*) FROM test WHERE test.id=@tid AND test.domain_id = domain.id)=1;', {'@tid': testid});
        let domain = await stmt.get();
        await stmt.finalize();
        stmt = await db.prepare('SELECT * FROM problem WHERE domain_id = @domain_id', { '@domain_id': domain.id });
        let problems = await stmt.all();
        await stmt.finalize();

        let relations = [];
        for (let j = 0; j < problems.length; j++) {
            let problem = problems[j];

            stmt = await db.prepare('SELECT * FROM problem_relation WHERE parent_id = @problem_id OR child_id = @problem_id', { '@problem_id': problem.id });
            let problem_relations = await stmt.all();
            await stmt.finalize();

            relations = relations.concat(problem_relations);
        }

        relations = relations.filter((rel1, index, self) =>
            index === self.findIndex((rel2) => (
                rel1.parent_id === rel2.parent_id && rel1.child_id === rel2.child_id
            ))
        );

        domain.problems = problems;
        domain.relations = relations;

        await db.close()
        return domain;
    }
}

module.exports = repository;